Attribute VB_Name = "mdlCtrlPanel"
Option Explicit

Public Const CPL_ACCESS As Long = 1
Public Const CPL_APPWIZ_INDEX As Long = 2
Public Const CPL_DESC As Long = 3
Public Const CPL_WINDOWS_FIRE_WALL As Long = 4
Public Const CPL_JAVA_CTRL_PNL As Long = 9
Public Const CPL_OBDCCP32 As Long = 17
Public Const CPL_POWERCFG As Long = 18
Public Const CPL_TIMEDATE As Long = 22
Private Const OH_MY_CTRL_PNL_NUM As Long = 25

Private Type CtrlPanelInfo
    ClassName As String
    FileName As String
    TabNum As Long
End Type

Public udtCPI(OH_MY_CTRL_PNL_NUM - 1) As CtrlPanelInfo

'Rg[plJ
Private Declare Function SHRunControlPanel Lib "shell32" Alias "#161" (ByVal lpcszCmdLine As Long, ByVal hWndMsgParent As Long) As Long

'fBNgɑ΂pid擾
Private Declare Function SHILCreateFromPath Lib "shell32" Alias "#28" (ByVal pcwStr As Long, ByRef PidList As Long, ByRef rgfInOut As Long) As Long
Private Declare Function SHSimpleDListFromPath Lib "shell32" Alias "#162" (ByVal lpszPath As Long) As Long


'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FRg[pl\
'   F(i)hWnd    c EBhEnh
'         (i)OpenCpl c Rpl(tH[}bgFRpl,^u)
' ԂlFFTrue  ُFFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function OpenControlPanel(ByVal hWnd As Long, Optional ByVal OpenCol As String = "") As Boolean
    OpenControlPanel = SHRunControlPanel(StrPtr(OpenCol), hWnd)
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FfBNgpid擾
'   F(i)TargetDir c ΏۃfBNg
' ԂlFipdԂ   G[ 0
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Private Function GetPidFromDir(ByVal TargetDir As String) As Long
    Dim Rgf As Long
    Dim lpTargetPath As Long
    Dim FuncRet As Long

    '̐擪AhX擾
    lpTargetPath = StrPtr(TargetDir)

    'fBNgɑ΂pid擾
    FuncRet = SHILCreateFromPath(lpTargetPath, GetPidFromDir, Rgf)
    If FuncRet <> 0 Then
        'G[̕ی(͂ǂΗǂ̂)
        GetPidFromDir = SHSimpleDListFromPath(lpTargetPath)
        If GetPidFromDir = 0 Then Exit Function
    End If

End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FCtrlPanelInfo\̂ɂPCɂRplݒ肷
'   FȂ
' ԂlFȂ
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Sub SetCtrlPanelInfo()
    Dim OhMyPCCtrlPnl(OH_MY_CTRL_PNL_NUM - 1) As String
    Dim CtrlData() As String
    Dim i As Long
    
    OhMyPCCtrlPnl(0) = ",Rg[pl,0"
    OhMyPCCtrlPnl(CPL_ACCESS) = "access.cpl,[U[⏕̃IvV,5"
    OhMyPCCtrlPnl(CPL_APPWIZ_INDEX) = "appwiz.cpl,vO̒ǉƍ폜,4"
    OhMyPCCtrlPnl(CPL_DESC) = "desk.cpl,ʂ̃vpeB,5"
    OhMyPCCtrlPnl(CPL_WINDOWS_FIRE_WALL) = "firewall.cpl,Windowst@CAEH[,3"
    OhMyPCCtrlPnl(5) = "hdwwiz.cpl,n[hEFA̒ǉEBU[h,0"
    OhMyPCCtrlPnl(6) = "inetcpl.cpl,C^[lbg̃vpeB,7"
    OhMyPCCtrlPnl(7) = "intl.cpl,nƌ̃IvV,3"
    OhMyPCCtrlPnl(8) = "joy.cpl,Q[ Rg[,0"
    OhMyPCCtrlPnl(CPL_JAVA_CTRL_PNL) = "jpicpl32.cpl,Java Rg[pl,5"
    OhMyPCCtrlPnl(10) = "main.cpl,}EX̃vpeB,5"
    OhMyPCCtrlPnl(11) = "mmsys.cpl,TEhƃI[fBI foCX̃vpeB,5"
    OhMyPCCtrlPnl(12) = "ncpa.cpl,lbg[Nڑ,0"
    OhMyPCCtrlPnl(13) = "netsetup.cpl,lbg[N ZbgAbv EBU[h,0"
    OhMyPCCtrlPnl(14) = "nusrmgr.cpl,[U[ AJEg,0"
    OhMyPCCtrlPnl(15) = "nvcpl.cpl,NVIDIA Rg[pl,0"
    OhMyPCCtrlPnl(16) = "nvtuicpl.cpl,nView Desktop Manager,0"
    OhMyPCCtrlPnl(CPL_OBDCCP32) = "odbccp32.cpl,ODBC f[^\[X Ah~jXg[^,7"
    OhMyPCCtrlPnl(CPL_POWERCFG) = "powercfg.cpl,dIvṼvpeB,4"
    OhMyPCCtrlPnl(19) = "RTSndMgr.Cpl,REALTEK,0"  '^u͂TǃftHgIws\
    OhMyPCCtrlPnl(20) = "sysdm.cpl,VXẽvpeB,7"
    OhMyPCCtrlPnl(21) = "telephon.cpl,ݒn,0"
    OhMyPCCtrlPnl(CPL_TIMEDATE) = "timedate.cpl,tƎ̃vpeB,3"
    OhMyPCCtrlPnl(23) = "wscui.cpl,Windows ZLeB Z^[,0"
    OhMyPCCtrlPnl(24) = "wuaucpl.cpl,XV,0"

    For i = 0 To OH_MY_CTRL_PNL_NUM - 1
        'OhMyPCCtrlPnl(x)𕶎zϐɕA\̂ɐݒ肷
        Call SplitData(OhMyPCCtrlPnl(i), ",", CtrlData())
        With udtCPI(i)
            .FileName = CtrlData(0)
            .ClassName = CtrlData(1)
            .TabNum = CLng(CtrlData(2))
        End With
    Next i

End Sub

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \Fw̃f~^Pʂŕ𕪊
'   F(i)Expression c Ώە
'         (i)Delimiter  c f~^
'         (o)StrData    c 㕶
'         (i)IsBinaryCompare c f~^̔r[h
'                               True FvbBinaryCompare oCir
'                               FalseFvbTextCompare   eLXgr
' ߂lFvf
'   lFCompareMode  vbTextCompareAvbBinaryCompare ȊO
'         lݒ肳Ăꍇ vbTextCompare ɂȂ!!
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Private Function SplitData(ByVal Expression As String, _
                          ByVal Delimiter As String, _
                          ByRef StrData() As String, _
                          Optional ByVal IsBinaryCompare As Boolean = True) As Long

    'ΏەAf~^w̏ꍇ́Az̐擪ɋ󕶎ݒ肵ďI
    If Expression = "" Or Delimiter = "" Then
        ReDim StrData(0) As String
        StrData(0) = Expression
        SplitData = UBound(StrData) + 1
        Exit Function
    End If

    Dim SearchPos As Long
    Dim FoundPos As Long
    Dim CompareMode As Long

    'r[hݒ
    CompareMode = IIf(IsBinaryCompare, vbBinaryCompare, vbTextCompare)

    'ʒu
    SearchPos = 1

    'ŌɃf~^
    Expression = Expression & Delimiter

    Do
        'f~^
        FoundPos = InStr(SearchPos, Expression, Delimiter, CompareMode)

        'f~^ȂȂI
        If FoundPos = 0 Then Exit Do

        '̈mہA擾i[
        ReDim Preserve StrData(SplitData) As String
        StrData(SplitData) = Mid$(Expression, SearchPos, FoundPos - SearchPos)

        '񌟍ʒuZo
        SearchPos = FoundPos + Len(Delimiter)

        'f[^JEg
        SplitData = SplitData + 1
    Loop

End Function


